'based on ' mouse.bas' by  Don (don67geo@yahoo.com) 
'  modified and translated opengl mouse.c into hotbasic source. 
' 
$typecheck ON
$INCLUDE <RapidQ2.inc>
$INCLUDE <GL\QGL.inc>

DECLARE SUB FormCreate
DECLARE SUB FormKeyDown (Key AS Word, KeyShift AS INTEGER)
DECLARE SUB FormMouseDown (Button%, X%, Y%, Shift%)
DECLARE SUB FormMouseMove (X%, Y%, Shift%)
DECLARE SUB FormMouseUp(Button%, X%, Y%, Shift%)
DECLARE SUB FormSize
DECLARE sub meshbuilder
DECLARE sub meshframe(state as integer, ox as integer, nx as integer, oy as integer, ny as integer)
DECLARE sub setrendermode
DECLARE sub setvisual(iw as integer, ih as integer)

DECLARE sub GenerateTerrain
DIM meshList as glInt


$define PAN    1
$define ROTATE 2
$define ZOOM   3
$define MaxX    512
$define MaxY    512
$define MaxZ    512
defint mx,my,dx,dy
dim trans(3) as single
dim rotat(2) as single

DIM X AS glInt
DIM Y AS glInt
DIM R0 AS glInt
DIM R1 AS glInt
DIM R2 AS glInt
DIM R3 AS glInt
DIM R4 AS glInt
DIM A%(MaxX, MaxY)
DEFINT D,M,N,R,S,T,H,V,K,Q
DEFSNG ROJO,VERDE,AZUL,ANG

DEFINT state = 0
DIM GL AS QGL
'-- user interface here 
create Form as QFORM
  caption       = "OpenGL Fractal Demo"
  center
  width         = 1024
  height        = 768
  onpaint       = meshbuilder
  onmouseup     = FormMouseUp
  onmousedown   = FormMouseDown
  onmousemove   = FormMouseMove
'  onshow        = FormCreate
  onkeydown     = FormKeyDown
  onresize      = FormSize
end create
FormCreate
GenerateTerrain
Form.showmodal
end


sub meshframe(state as integer, ox as integer, nx as integer, oy as integer, ny as integer)
    dx = ox - nx
    dy = ny - oy
    select case state
      case PAN:    trans(0) = trans(0) - dx
                   trans(1) = trans(1) - dy
      case ROTATE: rotat(0) = rotat(0) + (dy * 18.0) / 10.0
                   rotat(1) = rotat(1) - (dx * 18.0) / 10.0
      case ZOOM:   trans(2) = trans(2) - (dx + dy)
    end select
end sub

sub setrendermode
    glEnable(GL_DEPTH_TEST)
end sub

sub setvisual(iw as integer, ih as integer)
    defdbl aspect = iw/ih
    glViewport(0, 0, iw, ih)
    glMatrixMode(GL_PROJECTION)
    glLoadIdentity
    gluPerspective(75.0,aspect,0.1,MAXZ*2.0)
    glMatrixMode(GL_MODELVIEW)
    glLoadIdentity
    glTranslatef(0.0, 0.0, -MaxZ*1.0)
end sub

sub meshbuilder
    ' rotate a triangle around 
    glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT)
    glPushMatrix
    glTranslatef(trans(0), trans(1), trans(2))
        glRotatef(rotat(0), 1.0, 0.0, 0.0)
    glRotatef(rotat(1), 0.0, 1.0, 0.0)
    glClearColor(0.0,0.0,0.0,0.0)
    glCallList(meshList)
    glPopMatrix
    GL.Flip
end sub


SUB FormCreate
    GL.Init(Form)
   setrendermode
      meshList=glGenLIsts(1)
END SUB

SUB FormMouseDown (Button%, X%, Y%, Shift%) 
  if Button% = 0 then state = ROTATE  'or state 
  if Button%= 1 then state = PAN 'or state 
  if Button%= 2 then state = ZOOM 'or state 
  mx = X%'Screen.mouseX 
  my = Y%'Screen.mouseY 
END SUB

SUB FormMouseUp(Button%, X%, Y%, Shift%)
   state = 0
END SUB


SUB FormMouseMove (X%, Y%, Shift%)
     meshframe(state, mx, X%, my, Y%)
     mx = X%
     my = y%
     meshbuilder
     GL.Flip
END SUB

SUB FormKeyDown (Key AS Word, KeyShift AS INTEGER) 
  if key = 27 then
    GL.Close
    Form.close
  end if
  if key = 32 then
   GenerateTerrain
   meshbuilder
  end if
'  if KeyShift THEN state = STATE XOR PAN
  SELECT CASE Key
  CASE 33 ' Page Up
  state = ZOOM
  meshframe(state,0,2,0,0)
     meshbuilder
  state = 0
     GL.Flip
  CASE 34 ' Page Down
  state = ZOOM
  meshframe(state,2,0,0,0)
     meshbuilder
  state = 0
     GL.Flip
  CASE 37 ' Left Arrow
  state = ROTATE
  if KeyShift THEN state = PAN
  meshframe(state,2,0,0,0)
     meshbuilder
  state = 0
     GL.Flip
  CASE 38 ' Up Arrow
  state = ROTATE
  if KeyShift THEN state = PAN
  meshframe(state,0,0,2,0)
     meshbuilder
  state = 0
     GL.Flip
  CASE 39 ' Right Arrow
  state = ROTATE
  if KeyShift THEN state = PAN
  meshframe(state,0,2,0,0)
     meshbuilder
  state = 0
     GL.Flip
  CASE 40 ' Down Arrow
  state = ROTATE
  if KeyShift THEN state = PAN
  meshframe(state,0,0,0,2)
     meshbuilder
  state = 0
     GL.Flip
  CASE ELSE
  state = 0
  meshframe(state,0,0,0,0)
     meshbuilder
     GL.Flip
  END SELECT
END SUB


SUB FormSize
  GL.Resize(form.clientWidth, form.clientHeight)
  setvisual(GL.width, GL.height)
  meshbuilder
END SUB
 
SUB GenerateTerrain
MEMSET(VARPTR(A%(0,0)), 0, (MaxX+1)*(MaxY+1)*SIZEOF(SHORT))

' FOR M=0 TO MaxX: FOR N=0 TO MaxY
' A%(M, N) = 0
' NEXT N: NEXT M

RANDOMIZE TIMER
S = MaxZ: R = 1
WHILE S>1
D = S / 2: K = 0.5 * D + 1
FOR N = 1 TO R
FOR M = 1 TO R
H = N * S - D: V = M * S - D
A%(H - D, V) = (A%(H - D, V - D) + A%(H - D, V + D)) / 2 + INT((2 * RND - 1) * K)
A%(H, V + D) = (A%(H - D, V + D) + A%(H + D, V + D)) / 2 + INT((2 * RND - 1) * K)
A%(H, V) = (A%(H + D, V + D) + A%(H + D, V - D) + A%(H - D, V - D) + A%(H - D, V + D)) / 4 + INT((2 * RND - 1) * K)
NEXT M: NEXT N
S = D: R = R * 2
WEND


      glNewList(meshList,GL_COMPILE)
        glPolygonMode(GL_FRONT_AND_BACK, GL_FILL)
        glEnable(GL_CULL_FACE)
        glCullFace (GL_FRONT)
    
FOR Y = 0 TO MaxY -1
    glBegin(GL_QUAD_STRIP)
FOR X = 0 TO MaxX -1
R1 = A%(X, Y + 1): REM IF R1 < 0 THEN R1 = 0
R2 = A%(X, Y): REM IF R2 < 0 THEN R2 = 0
R3 = A%(X + 1, Y + 1): REM IF R3 < 0 THEN R3 = 0
R4 = A%(X + 1, Y): REM IF R4 < 0 THEN R4 = 0
R0 = (R4 + R1 + R2 + R3) / 4
D=&HFF0000
IF R0<-12 THEN D=&HCC0000
IF R0<-24 THEN D=&H990000
IF R0<-36 THEN D=&H660000
IF R0>0 THEN D=&H00CCFF
IF R0>=6 THEN D=&H00CC00
IF R0>=16 THEN D=&H009900
IF R0>=24 THEN D=&H009966
IF R0>=32 THEN D=&H006666
IF R0>=40 THEN D=&HFFFFFF
 ANG = ( ATN( SQR( (R3 - R1)*(R3 - R1) + (R2 - R1)*(R2 - R1) ) ) ) * 45/ATN(1)
 IF ANG<0 THEN ANG=ANG+90
Q=INT (ANG)

AZUL=((D And &HFF0000)/&H10000):If AZUL>Q Then AZUL=AZUL-Q Else AZUL=0
VERDE=((D And &H00FF00)/&H100):If VERDE>Q Then VERDE=VERDE-Q Else VERDE=0
ROJO=(D And &H0000FF):If ROJO>Q Then ROJO=ROJO-Q Else ROJO=0

glColor3f(ROJO/255,VERDE/255,AZUL/255)
' glNormal3i(R1-R3,1,R2-R1)
glVertex3i(X-MaxX/2, R1, Y-MaxY/2)
' glNormal3i(R2-R1,1,R4-R2)
glVertex3i(X-MaxX/2, R2, Y-1-MaxY/2)

NEXT X
' glNormal3i(R3-R4,1,R1-R3)
glVertex3i(X+1-MaxX/2, R3, Y-MaxY/2 )
' glNormal3i(R4-R2,1,R3-R4)
glVertex3i(X+1-MaxX/2, R4, Y-1-MaxY/2)
    glEnd
NEXT Y
    glEndList
FormSize
END SUB

